SoBumpMapMatrixElement Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SoBumpMapMatrixElement Class Reference
Element Classes

The SoBumpMapMatrixElement class is used to manage the bump map matrix stack.The bump map matrix is used to transform bump map coordinates before being used to map bump maps onto polygons. More...

`#include <Inventor/elements/SoBumpMapMatrixElement.h>`

Inheritance diagram for SoBumpMapMatrixElement:

## Public Member Functions
virtual void | init (SoState *state)
virtual void | push (SoState *state)
Public Member Functions inherited from SoAccumulatedElement
virtual SbBool | matches (const SoElement *element) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | makeIdentity (SoState *const state, SoNode *const node)
static void | set (SoState *const state, SoNode *const node, const SbMatrix &matrix)
static void | mult (SoState *const state, SoNode *const node, const SbMatrix &matrix)
static void | translateBy (SoState *const state, SoNode *const node, const SbVec3f &translation)
static void | rotateBy (SoState *const state, SoNode *const node, const SbRotation &rotation)
static void | scaleBy (SoState *const state, SoNode *const node, const SbVec3f &scaleFactor)
static const SbMatrix & | get (SoState *const state)
Static Public Member Functions inherited from SoAccumulatedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
virtual | ~SoBumpMapMatrixElement ()
virtual void | makeEltIdentity (void)
virtual void | setElt (const SbMatrix &matrix)
virtual void | multElt (const SbMatrix &matrix)
virtual void | translateEltBy (const SbVec3f &translation)
virtual void | rotateEltBy (const SbRotation &rotation)
virtual void | scaleEltBy (const SbVec3f &scaleFactor)
virtual const SbMatrix & | getElt (void) const
Protected Member Functions inherited from SoAccumulatedElement
void | clearNodeIds (void)
void | addNodeId (const SoNode *const node)
void | setNodeId (const SoNode *const node)
void | copyNodeIds (const SoAccumulatedElement *copyfrom)
virtual SoElement * | copyMatchInfo (void) const
virtual void | captureThis (SoState *state) const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Protected Attributes
SbMatrix | bumpMapMatrix
Protected Attributes inherited from SoAccumulatedElement
SbList< uint32_t > | nodeIds
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoBumpMapMatrixElement class is used to manage the bump map matrix stack.

The bump map matrix is used to transform bump map coordinates before being used to map bump maps onto polygons.

## Constructor & Destructor Documentation

SoBumpMapMatrixElement::~SoBumpMapMatrixElement | ( | void |  | ) |
| protectedvirtual

The destructor.

## Member Function Documentation

void * SoBumpMapMatrixElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoBumpMapMatrixElement::init | ( | SoState * | state | ) |
| virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoAccumulatedElement.

void SoBumpMapMatrixElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoAccumulatedElement.

void SoBumpMapMatrixElement::makeIdentity | ( | SoState *const | state,
|  | SoNode *const | node
| ) |  |
| static

Sets current texture matrix to identity.

void SoBumpMapMatrixElement::set | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbMatrix & | matrix
| ) |  |
| static

Sets the current texture matrix to matrix.

This method is an extension versus the Open Inventor API.

void SoBumpMapMatrixElement::mult | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbMatrix & | matrix
| ) |  |
| static

Multiplies matrix into the current texture matrix.

void SoBumpMapMatrixElement::translateBy | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbVec3f & | translation
| ) |  |
| static

Appends translation to the current texture matrix.

void SoBumpMapMatrixElement::rotateBy | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbRotation & | rotation
| ) |  |
| static

Appends rotation to the current texture matrix.

void SoBumpMapMatrixElement::scaleBy | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbVec3f & | scaleFactor
| ) |  |
| static

Appends scaleFactor to the current texture matrix.

const SbMatrix & SoBumpMapMatrixElement::get | ( | SoState *const | state | ) |
| static

Returns current texture matrix.

void SoBumpMapMatrixElement::makeEltIdentity | ( | void |  | ) |
| protectedvirtual

virtual method which is called from makeIdentity(). Sets element matrix to identity.

void SoBumpMapMatrixElement::setElt | ( | const SbMatrix & | matrix | ) |
| protectedvirtual

virtual method which is called from set(). Sets the texture matrix to matrix.

This method is an extension versus the Open Inventor API.

void SoBumpMapMatrixElement::multElt | ( | const SbMatrix & | matrix | ) |
| protectedvirtual

virtual method which is called from mult(). Multiplies matrix into element matrix.

void SoBumpMapMatrixElement::translateEltBy | ( | const SbVec3f & | translation | ) |
| protectedvirtual

virtual method which is called from translateBy(). Appends translation to the element matrix.

void SoBumpMapMatrixElement::rotateEltBy | ( | const SbRotation & | rotation | ) |
| protectedvirtual

virtual method which is called from rotateBy(). Appends rotation to the element matrix.

void SoBumpMapMatrixElement::scaleEltBy | ( | const SbVec3f & | scaleFactor | ) |
| protectedvirtual

virtual method which is called from scaleBy(). Append scaleFactor to the element matrix.

const SbMatrix & SoBumpMapMatrixElement::getElt | ( | void |  | ) | const
| protectedvirtual

Returns element matrix. Called from get().

## Member Data Documentation

SoBumpMapMatrixElement::bumpMapMatrix
| protected

The matrix.

The documentation for this class was generated from the following files:

- SoBumpMapMatrixElement.h
- SoBumpMapMatrixElement.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.